.8086
;-----------------------------------------------------------
;       CheckEPSON
;-----------------------------------------------------------
CheckEPSON      PROC   near
                xor     ax,ax
                mov     es,ax
                mov     ax,0FD80h       ; seg
                mov     bx,0002h        ; ofs
                mov     cx,2A27h        ; EPSON 27h,2Ah (Normal)
                test    byte ptr es:[0501h],8
                jz      EpsonNormalMode
                mov     ax,0F800h       ; seg
                mov     bx,07F70h       ; ofs
                mov     cx,1827h        ; EPSON 27h,18h (Hireso)
EpsonNormalMode:  
                mov     es,ax
                cmp     es:[bx],cx      ; compare
                je      IsEPSONPC
                clc
                ret
IsEPSONPC:      
                mov     al,es:[3]       ; EPSON ID
                mov     ah,0
                mov     dx,offset msg_EPSON
                call    _puts
                or      flagset,F_NO_HOOK
                stc     ; CY=EPSON PC
                ret
msg_EPSON       DB      041h,"EPSON@RAM BIOSpb`DISK BIOStbN̑ΏۊOł. ᑬœ.",13,10,0
CheckEPSON      ENDP
;--------------------------------------------------------------------------
;       IsBuiltInBIOS   SOUND BIOS{̓̂ǂ`FbN es=CC00
;-----------------------------------------2022/9/24------------------------
IsBuiltInBIOS   PROC   near
                push    es
                push    ds
                mov     ax,es
                mov     ds,ax
                mov     es,SegTempMem
                PrepMemMove     1000h
        rep     movsw
                pop     ds
                pop     es

                mov     dx,053Dh
                mov     al,equip        ;
                or      al,10000010b
                out     dx,al           ; ݒs
                
                PrepMemMove     1000h

                mov     dx,0461h
                mov     al,0Ch
                out     dx,al

                push    es
                push    ds
                mov     ax,8C00h
                mov     es,ax
                mov     ds,SegTempMem
                mov     cx,1000h/2
        rep     cmpsw
                pop     ds
                pop     es

                mov     dx,0461h
                mov     al,08h
                out     dx,al

                or      cx,cx
                jnz     NoBuiltInBIOS   ; BIOSƂ 
                mov     al,10000010b    
                or      equip,al
                clc                     ; BIOSƂNC
                ret
NoBuiltInBIOS:  mov     al,equip        ;
                and     al,01111111b    ; BIOŜ͖őbitւ܂
                mov     equip,al        ; tOɂݒԂ
                out     dx,al           ; ݒs
                stc                     ; BIOSƂCY
                ret
IsBuiltInBIOS   ENDP
.386
;----------------------------------
;       inquery_equip
;----------------------------------
inquery_equip   PROC   near
                mov     dx,00F0h
                in      al,dx
                test    al,00100000b
                jnz     end_sasi
                push    es
                mov     ax,0D700h
                mov     es,ax
                mov     eax,es:[0]
                cmp     eax,0FFFFFFFFh
                je      end_sasi
                or      equip,SASI_EQUIP
end_sasi:
                test    al,01000000b
                jnz     end_scsi
                or      equip,SCSI_EQUIP
end_scsi:
                test    flagset,F_HIRESO
                jz      EndBiosEquipCheck
; TEhBIOS̏u
                mov     ax,0CC00h
                mov     es,ax
                mov     eax,es:[bx]
                or      eax,eax
                jz      NoSNDBIOS
                cmp     eax,0FFFFFFFFh  ; ROM not exist
                je      NoSNDBIOS
                call    IsBuiltInBIOS  ; f[^̂łɃ`FbN
                jc      NoSNDBIOS
                or      equip, SNDB_equip 
                jmp     EndCheckSoundBIOS
NoSNDBIOS:      and     equip,01111111b ; BIOS͂Ȃ̂ő݃tO߂
EndCheckSoundBIOS:
                test    equip,SNDB_equip
                jz      EndBiosEquipCheck
                mov     dx,offset msg_eq_sndb
                call    _puts
EndBiosEquipCheck:
                test    flagset, F_INDOS
                jz      DisplayEquipEnd
                test    equip,SCSI_EQUIP
                jz      @f
                mov     dx,offset msg_eq_scsi
                call    _puts
        @@:
                test    equip,SASI_EQUIP
                jz      @f
                mov     dx,offset msg_eq_sasi
                call    _puts
        @@:
                mov     al,equip
                shl     al,4
                or      al,al
                jnz     @f
                mov     dx,offset msg_eq_none
                call    _puts
        @@:
DisplayEquipEnd:
                ret
inquery_equip   ENDP

